# -*- coding: utf-8 -*-
"""
Created on Fri Jul 12 00:36:50 2013

@author: Christian
"""



from PyQt4.QtCore import *
from PyQt4.QtGui import *

from schemaobject import SchemaObject

from spyndle import Line




""" 
 We cannot use QLine because  Link would inherit QObject through SchemaObject 
 and through QLine and it is not allowed to inherit two times QObject in PyQt.
 http://stackoverflow.com/questions/17621975/python-error-typeerror-could-not-convert-x-to-y-in-multiple-inheritance
"""
class Line(object):
    def __init__(self):
        self.setLine(0, 0, 0, 0)
    
    def setLine(self, x1, y1, x2, y2):
        self.__x1 = int(x1)
        self.__y1 = int(y1)
        self.__x2 = int(x2)
        self.__y2 = int(y2)        


    def setP1(self, p1):
        self.__x1 = p1.x()
        self.__y1 = p1.y()
        
    def setP2(self, p2):
        self.__x2 = p2.x()
        self.__y2 = p2.y()
        
    def x1(self) : return self.__x1
    def y1(self) : return self.__y1
    def x2(self) : return self.__x2
    def y2(self) : return self.__y2

    def p1(self) : return QPoint(int(self.__x1), int(self.__y1))
    def p2(self) : return QPoint(int(self.__x2), int(self.__y2))




class Link(SchemaObject, Line):

    def __init__(self, parent) :
        SchemaObject.__init__(self, parent)
        QLine.__init__(self, parent)

        if parent :
            self.setAutoFillBackground(True)
            self.setGeometry(self.parent.rect())
            self.setFocusPolicy(Qt.StrongFocus)
            self.setBackgroundRole(QPalette.Window)
    
            # set black background
            pal = self.palette()
            pal.setColor(QPalette.Window, Qt.black);
            self.setPalette(pal)


    def paintEvent(self, event):
    
        pal = self.palette()
        
        # set black background
        if self.hasFocus():
            pal.setColor(QPalette.Window, Qt.red)
        else :
            pal.setColor(QPalette.Window, Qt.black)
        self.setPalette(pal)
        super(Link, self).paintEvent(event)
    
    

    def mousePressEvent(self, event): 
        self.update()


    # For walking though the schema. Arrows are not aware of the object they are connected to.
    def getNbPreviousObject()   : return 0
    def getNbNextObject()       : return 0
    def previousObject()        : return None
    def nextObject()            : return None




class ArrowLink(Link):
    
   
    # Emitted when the focus has changed from one object to another in the canevas.
    # This allows, for exemple, to update the object properties window. The newly
    # selected object is passed as parameter.
    updateEvent = pyqtSignal(QRegion)    
    
    def __init__(self, parent) :
        Link.__init__(self, parent)
    
        pal = self.palette()
        #set black background
        pal.setColor(QPalette.Window, Qt.black)
        self.setAutoFillBackground(True)
        self.setBackgroundRole(QPalette.Window)
        self.setPalette(pal)
        
        self.setLine(0, 0, 0, 0)


    def redefine(self, oldP1, oldP2):
        if self.parentWidget() :
            
            mask = QBitmap(self.parentWidget().size())
            mask.clear()
            
            painter = QPainter()
            painter.begin(mask);
            painter.setPen(Qt.color1)
            painter.drawLine(self.x1(), self.y1(), self.x2(), self.y2())
            painter.end();
            
            self.setMask(mask);
            self.show();

            oldRegion = QRegion(QPolygon([oldP1, oldP2]))
            newRegion = QRegion(QPolygon([self.p1(), self.p2()]))
            self.updateEvent.emit(newRegion.united(oldRegion))
    

    def setP1(self, p1):
        super(ArrowLink, self).setP1(p1)
        self.redefine(p1, self.p2())


    def setP2(self, p2):
        super(ArrowLink, self).setP2(p2)
        self.redefine(self.p1(), p2)




    def formatObjectCode(self): pass




