# -*- coding: utf-8 -*-
"""
Created on Thu Jul 11 15:36:10 2013

@author: Christian
"""


from PyQt4.QtCore import *
from PyQt4.QtGui import *

from constant import PORT_SIZE

#include "global.h"

SIZEPOINT_TOP    = 1
SIZEPOINT_BOTTOM = 2
SIZEPOINT_LEFT   = 4
SIZEPOINT_RIGHT  = 8


class SizePoint(QWidget): 

    def __init__(self, parent, typePoint):
        QWidget.__init__(self, parent)

        Pal = self.palette()
        Pal.setColor(QPalette.Window, Qt.red)
        self.setPalette(Pal)
        self.setBackgroundRole(QPalette.Window)
        self.setAutoFillBackground(True)
        #self.setStyleSheet("QWidget {background-color: #0000FF }")
        #self.show()

        # Are we currently in a drag-and-drop operation
        self.bDragging = False

        # Last recorded position of the mouse
        self.lastMousePos = None

        # What kind of size point is it.
        self.typePoint = typePoint;

    
        self.setGeometry(0,0,4, 4)
        self.setVisible(False)
    
        if self.typePoint & SIZEPOINT_TOP:
            if self.typePoint & SIZEPOINT_LEFT:
                self.setCursor(Qt.SizeFDiagCursor)
            elif self.typePoint & SIZEPOINT_RIGHT:
                self.setCursor(Qt.SizeBDiagCursor)
            else : 
                self.setCursor(Qt.SizeVerCursor);

        elif self.typePoint & SIZEPOINT_BOTTOM:
            if self.typePoint & SIZEPOINT_LEFT:
                self.setCursor(Qt.SizeBDiagCursor )
            elif self.typePoint & SIZEPOINT_RIGHT:
                self.setCursor(Qt.SizeFDiagCursor )
            else:
               self.setCursor(Qt.SizeVerCursor)
               
        elif self.typePoint & SIZEPOINT_LEFT:
            self.setCursor(Qt.SizeHorCursor)
            
        elif self.typePoint & SIZEPOINT_RIGHT:
            self.setCursor(Qt.SizeHorCursor )

    
    
    def mousePressEvent(self, event):
        if event.button() == Qt.LeftButton:
            self.bDragging      = True
            self.lastMousePos   = event.globalPos()


    def mouseReleaseEvent(self, event):
        if event.button() == Qt.LeftButton:
            self.bDragging = False
    
    
    def mouseMoveEvent(self, event):
    
        if self.bDragging: 
            self.lastMousePos = self.mapToGlobal(QPoint(2,2))
            QApplication.desktop().cursor().setPos(self.lastMousePos)
    
            oldSize     = self.parentWidget().size()
            delta       = event.globalPos() - self.lastMousePos
            deltaSize   = QSize(delta.x(), delta.y())    
    
            # We dont change size in direction not allowed by the SizePoint object.
            if not (self.typePoint & SIZEPOINT_TOP or self.typePoint & SIZEPOINT_BOTTOM) :
                deltaSize.setHeight(0)
    
            if not (self.typePoint & SIZEPOINT_LEFT or self.typePoint & SIZEPOINT_RIGHT) :
                deltaSize.setWidth(0);
    
            if self.typePoint & SIZEPOINT_TOP:
                deltaSize.setHeight(-deltaSize.height())
    
            if self.typePoint & SIZEPOINT_LEFT:
                deltaSize.setWidth(-deltaSize.width())
    
    
            # We make sure to keep a minimum size of 4*PORT_SIZE X 4*PORT_SIZE
            newSize = deltaSize + self.parentWidget().size()
            if newSize.width() < 4*PORT_SIZE :
                newSize.setWidth(4*PORT_SIZE)
                delta.setX(( 1 if delta.x() > 0 else -1 )*(newSize - oldSize).width())
    

    
            if newSize.height() < 4*PORT_SIZE:
                newSize.setHeight(4*PORT_SIZE)
                delta.setY(( 1 if delta.y() > 0 else -1 )*(newSize - oldSize).height())
    
            self.lastMousePos += delta;
    

            QApplication.desktop().cursor().setPos(self.lastMousePos)

    
            blockPosition = self.parentWidget().pos()
            # If needed, we move the ProcessBlock so as to cancel
            # a moving illustion that would be produced by the resizing
            # of the block with a constant position at the upper left corner.
            if self.typePoint & SIZEPOINT_TOP :
                blockPosition.setY(blockPosition.y() - (newSize - oldSize).height() )
    
            if self.typePoint & SIZEPOINT_LEFT :
             blockPosition.setX(blockPosition.x() - (newSize - oldSize).width() )
    
            self.parentWidget().move(blockPosition)
    
            # We resize.
            self.parentWidget().resize(newSize)
