# -*- coding: utf-8 -*-
"""
Created on Thu Oct 17 00:12:09 2013

@author: Christian
"""


from cStringIO import StringIO

"""
 The communication hub is used to aggregate the messages from the various
 execution blocks and provide them on demand to any client. This object is used
 as a mediator between the message displaying process and the block process to
 avoid that pause of executing blocks due to access to shared memory by 
 diplayer pooling. 
"""

class CommunicationHub:
    
    def __init__(self):
        
        # Keys are PYRO URIs, values are BlockQueue objects
        self.__queue = {}
        self.readerIDs = []
        
    def addWorker(self, ID):
        self.__queue[ID] = WorkerQueue()
        self.readerIDs = self.__queue.keys()        
        
    def writeMessage(self, ID, message):
        print ID, message
        self.__queue[ID].msgQueue.write(message)
        
    def readMessage(self, ID):
        message = self.__queue[ID].msgQueue.read()
        if not self.__queue[ID].isRunning:
            del self.__queue[ID]
            self.readerIDs = self.__queue.keys()     
        return message

    def getReaderIDs(self):
        return self.readerIDs
        
        
    def terminateWorker(self, ID):    
        self.__queue[ID].isRunning = False     


    def test(self):
        pass


class WorkerQueue:
    
    def __init__(self):
        
        # A BlockPipe should be deleted from the CommunicationHub as soon as it 
        # is not running and  its has an empty msgeQueue
        # is empty.
        self.isRunning     = True
        self.msgQueue      = FifoBuffer()
        
            
        
        


# Copied from http://stackoverflow.com/a/10917767/1825043
class FifoBuffer(object):
    def __init__(self):
        self.buf = StringIO()
        self.available = 0    # Bytes available for reading
        self.size = 0
        self.write_fp = 0

    def read(self, size = None):
        """Reads size bytes from buffer"""
        if size is None or size > self.available:
            size = self.available
        size = max(size, 0)

        result = self.buf.read(size)
        self.available -= size

        if len(result) < size:
            self.buf.seek(0)
            result += self.buf.read(size - len(result))

        return result


    def write(self, data):
        """Appends data to buffer"""
        if self.size < self.available + len(data):
            # Expand buffer
            new_buf = StringIO()
            new_buf.write(self.read())
            self.write_fp = self.available = new_buf.tell()
            read_fp = 0
            while self.size <= self.available + len(data):
                self.size = max(self.size, 1024) * 2
            new_buf.write('0' * (self.size - self.write_fp))
            self.buf = new_buf
        else:
            read_fp = self.buf.tell()

        self.buf.seek(self.write_fp)
        written = self.size - self.write_fp
        self.buf.write(data[:written])
        self.write_fp += len(data)
        self.available += len(data)
        if written < len(data):
            self.write_fp -= self.size
            self.buf.seek(0)
            self.buf.write(data[written:])
        self.buf.seek(read_fp)